<?php

/*
If you are using and old WHMCS version and this callback doesn't work, uncomment these includes and comment out the New WHMCS Versions block below. - coinpay24
# Old WHMCS Versions
include("../../../dbconnect.php");
include("../../../includes/functions.php");
include("../../../includes/gatewayfunctions.php");
include("../../../includes/invoicefunctions.php");
# /Old WHMCS Versions
*/

/*
# New WHMCS Versions
*/
require("../../../init.php");
$whmcs->load_function('gateway');
$whmcs->load_function('invoice');
/*
# /New WHMCS Versions
*/

$gatewaymodule = "coinpay24"; # Enter your gateway module name here replacing template
$GATEWAY = getGatewayVariables($gatewaymodule);
// if (!$GATEWAY["type"]) die("Module Not Activated"); # Checks gateway module is active before accepting callback

function coinpay24_error($msg) {
	global $GATEWAY;
	
	if (!empty($GATEWAY['coinpay24_email'])) {
		$report = "AUTH User: ---- \n";
		$report .= "AUTH Pass: ---- \n\n";
				
		if ($msg) {
			$report .= "Error Message: ".$msg."\n\n";
		}
			
		$report .= "POST Fields\n\n";
		foreach ($_POST as $key => $value) {
			$report .= $key . '=' . $value. "\n";
		}
			
		mail($GATEWAY['coinpay24_email'], "coinpay24.com Invalid IPN", $report);
	}
	die('IPN Error: '.$msg);
}

	if (isset($_SERVER['HTTP_IPN_HMAC']) && !empty($_SERVER['HTTP_IPN_HMAC'])) {
		$request = file_get_contents('php://input');
		if ($request !== FALSE && !empty($request)) {
			$hmac = hash_hmac("sha512", $request, trim($GATEWAY['coinpay24_ipn_secret']));
			if ($hmac != $_SERVER['HTTP_IPN_HMAC']) {
				coinpay24_error('HMAC signature does not match');
			}
		} else {
			coinpay24_error('Error reading POST data');
		}
	} else {
		coinpay24_error('No HMAC signature sent.');
	}

# Get Returned Variables - Adjust for Post Variable Names from your Gateway's Documentation
$status = $_POST["status"];
$status_text = $status;
$invoiceid = $_POST["order_id"];
$transid = $_POST["id"];
$amount1 = $_POST["price_amount"];
$amount2 = $_POST["pay_amount"];
$currency1 = $_POST["price_currency"];
$currency2 = $_POST["pay_currency"];
	
if ($amount1 <= 0) {
	coinpay24_error("Amount must be > 0!");
}

$invoiceid = checkCbInvoiceID($invoiceid,$GATEWAY["name"]); # Checks invoice ID is a valid invoice number or ends processing

checkCbTransID($transid); # Checks transaction number isn't already in the database and ends processing if it does

if ($status == 'paid') {
	addInvoicePayment($invoiceid,$transid,$amount1,0.00,$gatewaymodule); # Apply Payment to Invoice: invoiceid, transactionid, amount paid, fees, modulename
	logTransaction($GATEWAY["name"],$_POST,$status_text.' (Original Amount: '.sprintf('%.8f', $amount1).' '.$currency1.') (Coins Paid: '.sprintf('%.8f', $amount2).' '.$currency2.') (Make sure original currency matches your WHMCS currency!)'); # Save to Gateway Log: name, data array, status	
} elseif ($status == 'pending') {
	logTransaction($GATEWAY["name"],$_POST,'Pending: '.$status_text);
} else {
	logTransaction($GATEWAY["name"],$_POST,'Error: '.$status_text);
	coinpay24_error($status_text);
}

echo 'IPN OK';