<?php

function coinpay24_config() {
    $configarray = array(
     "FriendlyName" => array("Type" => "System", "Value"=>"CoinPay24.com"),
     "coinpay24_api_key" => array("FriendlyName" => "API KEY", "Type" => "text", "Size" => "32", 'Description' => 'Your API KEY can be found under the account settings section'),
     "coinpay24_ipn_secret" => array("FriendlyName" => "IPN Secret", "Type" => "password", "Size" => "32", 'Description' => 'Your IPN Secret can be found under merchant settings, you generate it yourself'),
    );
    //     "instructions" => array("FriendlyName" => "Payment Instructions", "Type" => "textarea", "Rows" => "5", "Description" => "Do this then do that etc...", ),
	return $configarray;
}

function coinpay24_link($params) {

	$fields = array(
        'order_id'          => $params['invoiceid'],
        'price_amount'      => number_format($params['amount'], 8, '.', ''),
        'price_currency'    => $params['currency'],
        'callback_url'      => $params['systemurl'] . 'modules/gateways/callback/coinpay24.php',
		'cancel_url'        => $params['systemurl'] . 'clientarea.php',
        'success_url'       => $params['systemurl'] . 'viewinvoice.php?id=' . $params['invoiceid'],
		'title'             => $params['companyname'],
        'description'       => $params['description']
	);

	// Send Data To CoinPay24
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, 'https://api.coinpay24.com/v1/invoices/create');
	curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($fields));
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
	curl_setopt($ch, CURLOPT_HTTPHEADER, array(
	  'Content-Type: application/json',
	  'X-API-KEY: ' . $params['coinpay24_api_key']
	));

	$response = curl_exec($ch);
	curl_close($ch);
	
	$response = json_decode($response);

	# Enter your code submit to the gateway...

    if($response->payment_url) {
        $form = '<form action="' . $response->payment_url . '" method="GET">';
        $form .= '<input type="submit" value="' . $params['langpaynow'] . '" />';
        $form .= '</form>';
        return $form;
    } else {
        $form = '<h2>' . $response->error_code . ' : ' . $response->error_message . '</h2>';
        $form .= '<h3>Please contact merchant for further details</h3>';
        return $form;
    }

}
